#!/usr/bin/perl -w

## get the shortest paths for the test data
## input: sid file, parse file and tag file

use strict;

#use lib "/data0/projects/clairlib-dev/lib";
use lib "/data0/projects/clairlib-1.01/clairlib/lib";

use Clair::Network;
use Clair::Network::Reader::Edgelist;

my $parseFile = shift; #input 1 from user
my $tagFile = shift; #input 2 from user

open (IN1, $parseFile) || die "cannot open $parseFile for reading: $!";
open (IN2, $tagFile) || die "cannot open $tagFile for reading: $!";

my $output_string = "";
my @relation_array;
my $i = 0;

my $line;
my $line2;

my $tag1;
my $tag2;

while (defined($line = <IN1>)) {
	$_ = $line;
	chomp;
	if (/^\s*$/) {
		if ($output_string ne "") {	
		    $line2 = <IN2>;
			my @tags = split(/\|#\|/,$line2);
			$tag1 = lc($tags[0]);
			$tag2 = lc($tags[1]);		
			paths(@relation_array);
		}
		$output_string = "";
		@relation_array = (); 
		$i = 0;
		next;
	}
	
	$relation_array[$i] = lc($_);

	$output_string .= $_."\n";
	
	$i++;
	
	#$output_string .= lc($t1)." ".lc($ind1)."\t".lc($relation)."\t".lc($t2)." ".lc($ind2)."\n";
	#$relation_array[$i]=lc($t1)."\t".lc($ind1)."\t".lc($relation)."\t".lc($t2)."\t".lc($ind2);
	
}

close(IN1);
close(IN2);

######################

sub paths {

	my @rels = @_;

	my $n = new Clair::Network(directed => 0);
	
	##my $tag1 = "protx1";
	##my $tag2 = "protx2";
	
	## create network ##
	# my @rels = split(/\|#\|/,$dep_hash{$sid});
	#print "$pmid\t$sid\n";

	#my $found_rel = 0;
	my %word_hash = ();
	
	#my @tag1_tokens = (); #token numbers (index in dep parse tree) for tag1 
	#my @tag2_tokens = (); #token numbers (index in dep parse tree) for tag2
	
	my $same_token = 0;
	my $tag1_found = 0;
	my $tag2_found = 0;
	
	
	foreach my $r (@rels){
		$_ = $r;
		s/\s+$//;
		/^([^\(]*)\((.*)\)$/;
		my $relation = $1;
		my ($part1,$part2) = split(/\,\ /,$2,2);
		
		#print STDERR "$part1 | $part2\n";
		
		$part1 =~ /^(.*)\-(\d+)'*$/;
		my $t1 = $1;
		my $ind1 = $2;
		
		## check if equal to tag1 or tag2
		
		my $same_token1 = $tag1 . "-" . $tag2;
		my $same_token2 = $tag2 . "-" . $tag1;
		
		#my $same_token = 0;
		#my $tag1_found = 0;
		#my $tag2_found = 0;
		
		#if ($t1 eq $tag1){
		#	push(@tag1_tokens, $ind1);
		#	$tag1_found = 1;
		#}
		#elsif ($t1 eq $tag2){
		#	push(@tag2_tokens, $ind1);
		#	$tag2_found =1;
		#}
		
		if (($t1 eq $same_token1) || ($t1 eq $same_token2)){
			$same_token = 1;
		}
		
		$word_hash{$ind1} = $t1;
		
		#print STDERR $ind1,"\n";
	
		$part2 =~ /^(.*)\-(\d+)'*$/;
		my $t2 = $1;
		my $ind2 = $2;
		
		
		## check if equal to tag1 or tag2
		
		#if ($t2 eq $tag1){
		#	push(@tag1_tokens, $ind2);
		#	$tag1_found = 1;
		#}
		#elsif ($t2 eq $tag2){
		#	push(@tag2_tokens, $ind2);
		#	$tag2_found = 1;
		#}
		if (($t2 eq $same_token1) || ($t2 eq $same_token2)){
			$same_token = 1;
		}

		$word_hash{$ind2} = $t2;

		
		#	print STDERR $part2,"\n";
		
		# create the network
		$n->add_node($ind1) unless $n->has_node($ind1); 
		$n->add_node($ind2) unless $n->has_node($ind2);
		$n->add_edge($ind1, $ind2);
		$n->set_edge_attribute($ind1, $ind2, 'relation', $relation);
		#print "$ind1\t$ind2\t$relation\n";
	}#foreach my r
	
	#create the wa and ta arrays
	
	my @wa = (); #word array in dep tree
	my @ta = (); #corresponding token # array in dep tree
	
	foreach my $ind (sort {$a <=> $b} keys %word_hash){
		push(@ta, $ind);
		push(@wa, $word_hash{$ind});
	}
	
	## extract the token numbers for the tags
	
	my %tag1_tokens = (); #token numbers (index in dep parse tree) for tag1 
	my %tag2_tokens = (); #token numbers (index in dep parse tree) for tag2
	
	my @tag1_words = split(/\s+/, $tag1);
	my @tag2_words = split(/\s+/, $tag2);
	
	my $last_index = ($#wa) - ($#tag1_words);
	
	for (my $i = 0; $i <= $last_index; $i++){
		my $num = 0;
		my $found = 0;
		
		foreach my $t (@tag1_words){
			my $k = $i + $num;
			
			if ($t eq $wa[$k]){
				$found = 1;
				$num++;
			}
			else{
				$found = 0;
				last;
			}
		} #foreach $t
		
		if ($found){
			$tag1_found = 1;
			my $token_num = 0;
			foreach my $t (@tag1_words){
				my $token_index = $i + $token_num;
				$tag1_tokens{$ta[$token_index]} = 1;
				$token_num++;
			}#foreach $t
		}#if found
	}
	
	## extract token indexes for tag2
	
	$last_index = ($#wa) - ($#tag2_words);
	
	for (my $i = 0; $i <= $last_index; $i++){
		my $num = 0;
		my $found = 0;
		
		foreach my $t (@tag2_words){
			my $k = $i + $num;
			
			if ($t eq $wa[$k]){
				$found = 1;
				$num++;
			}
			else{
				$found = 0;
				last;
			}
		} #foreach $t
		
		if ($found){
			$tag2_found = 1;
			my $token_num = 0;
			foreach my $t (@tag2_words){
				my $token_index = $i + $token_num;
				$tag2_tokens{$ta[$token_index]} = 1;
				$token_num++;
			}#foreach $t
		}#if found
	}#for i
	
	### extract the shortest path ###
	
	## check if the trigger and the prot are in the same token
	## if yes don't attemt to extarct a path. Path = "0"
	
	if ($same_token){ ## tag1 and tag2 are the same token path is 0 (tag1-tag2)
		print "0\t0\n";
		#$count++;
	}
	elsif ($tag1_found && $tag2_found) { ## if both tags matched in the tree -> extract the shortest path
		
		#print "tag1 and tag2 found\n"; 
		
		my @path_array = ();
		my $shortest_path_length = 10000;
		
		foreach my $v1 (keys %tag1_tokens){ #foreach matched token in the tag1
			foreach my $v2 (keys %tag2_tokens){ #foreach matched token in the tag2
			#for (my $v2 = $prot_start; $v2 <= $prot_end; $v2++){ #foreach token in the protein word
				#print "IN LOOP: $shortest_path_length", "\t$v1\t$v2\n";
				foreach my $path ($n->find_paths($v1,$v2)){
					my $length = @$path;
					#print $length, "\t", $shortest_path_length, "\t$v1\t$v2\n";
					if ($length < $shortest_path_length){
						$shortest_path_length = $length;
						@path_array = @$path;
						#$final_v1 = $v1;
						#$final_v2 = $v2;
					}
	
				}
			} #for v1
		} #for v2
		
		#print "EXTRACT PATH\n";
		
		#### print the shortest path
		
		my $first = 1;
		my $found = 0;
		my @sym_path = ();
		
		for (my $i = 0; $i < $#path_array; $i++){
			$found = 1;
			my $rel = $n->get_edge_attribute($path_array[$i], $path_array[$i+1], "relation");
			if ($first){
				print "$rel";
				$first = 0;
				push(@sym_path, $rel);
			}
			else{
				print " $word_hash{$path_array[$i]} $rel";
				push(@sym_path, $word_hash{$path_array[$i]});
				push(@sym_path, $rel);
			}
		}
		
		
		#### print the symetric shortest path
		if ($found){
			print "\t"; #separate the paths with tab
			for (my $i = $#sym_path; $i >= 0; $i--){
				if ($i == $#sym_path){
					print $sym_path[$i];
				}
				else{
					print " $sym_path[$i]";
				}
			}
		}
		
		
		#print "\t$final_v1\t$final_v2\n";
		print "\n";
	}
	else{
		#print "$sid tag1 and tag2 not found";
		print "\n";
	}
	

}#sub paths


